<script setup lang="ts">
import { onMounted } from 'vue'
import { useHomeStore } from '../store/home'
import PieChart from './charts/PieChart.vue'
import { ref } from 'vue'
import { ReportService } from '@/services/report'
import type { ReportProducts } from '../types/products'

const store = useHomeStore()
const productsTop = ref<ReportProducts[]>()
const productsWorst = ref<ReportProducts[]>()

onMounted(async () => {
  productsTop.value = await ReportService.getTopProducts(1)
  productsWorst.value = await ReportService.getTopProducts(-1)
})
</script>

<template>
  <v-col cols="12">
    <v-row no-gutters>
      <h2>Product Analytics</h2>
      <v-spacer></v-spacer>
      <h2>{{ store.selectBranch?.name ?? 'ALL' }}</h2>
    </v-row>
    <v-divider class="mt-2"></v-divider>
  </v-col>
  <v-col cols="6">
    <v-card rounded="lg" class="pa-5">
      <p>Top 5 Products sold</p>
      <v-divider class="my-2"></v-divider>
      <div class="d-flex justify-center pa-2">
        <PieChart
          :data="productsTop?.map((item) => item.totalPrice) ?? []"
          :labels="productsTop?.map((item) => item.name) ?? []"
        ></PieChart>
      </div>
      <v-data-table :items="productsTop"> <template #bottom></template></v-data-table>
    </v-card>
  </v-col>
  <v-col cols="6">
    <v-card rounded="lg" class="pa-5">
      <p>Worst 5 Products sold</p>
      <v-divider class="my-2"></v-divider>
      <div class="d-flex justify-center pa-2">
        <PieChart
          :data="productsWorst?.map((item) => item.totalPrice) ?? []"
          :labels="productsWorst?.map((item) => item.name) ?? []"
        ></PieChart>
      </div>
      <v-data-table :items="productsWorst"> <template #bottom></template></v-data-table>
    </v-card>
  </v-col>
</template>
